import { Reducer } from 'redux';
import { IAction } from './Actions';
export interface IActionReducer<TState, TActionPayload> {
    (state: TState, action: IAction<TActionPayload>): TState;
}
export interface IReduxRetroReducer<TState> extends Reducer<TState> {
    bindAction: <TNextActionPayload>(action: (...args: any[]) => TNextActionPayload, reducer: IActionReducer<TState, TNextActionPayload>) => IReduxRetroReducer<TState>;
}
export interface IPayloadCreator<TPayload> {
    (...args: any[]): TPayload;
    actionType?: string;
}
export interface IBoundAction<TActionPayload, TState> {
    payloadCreatorMethod: IPayloadCreator<TActionPayload>;
    reducerFunction: IActionReducer<TState, TActionPayload>;
}
export interface IReducerWrapper<TState> {
    reducer: IReduxRetroReducer<TState>;
}
export declare const reducer: {
    generateActionBinder<TState>(boundActions: IBoundAction<any, TState>[], mainReducer: IActionReducer<TState, any>): {
        bindAction<TNextActionPayload>(action: IPayloadCreator<TNextActionPayload>, actionReducer: IActionReducer<TState, TNextActionPayload>): IActionReducer<TState, TNextActionPayload>;
    };
    generateReducer<TState>(boundActions: IBoundAction<any, TState>[], initialState: TState): IReduxRetroReducer<TState>;
    createReducer<TState>(initialState: TState): IReduxRetroReducer<TState>;
};
export declare const createReducer: <TState>(initialState: TState) => IReduxRetroReducer<TState>;
